//---------------------------------------------------------------------------

#ifndef bixli1H
#define bixli1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QMenus.hpp>
#include <QTypes.hpp>
#include <QFileCtrls.hpp>
#include <QDialogs.hpp>
//---------------------------------------------------------------------------
class TFrmBixx : public TForm
{
__published:	// IDE Υݡͥ
        TListBox *ListBox1;
        TMainMenu *MainMenu1;
        TMenuItem *F1;
        TMenuItem *mnOpenDir;
        TMenuItem *mnRename;
        TMenuItem *mnCopy;
        TMenuItem *mnMove;
        TMenuItem *mnNewDir;
        TMenuItem *Delete1;
        TMenuItem *Reload1;
        TMenuItem *N1;
        TMenuItem *mnAddgo;
        TMenuItem *mnApplication;
        TMenuItem *mnSetting;
        TMenuItem *N2;
        TMenuItem *Quit1;
        TMenuItem *mnPreGeneral;
        TMenuItem *mnPreUtil4Ext;
        TMenuItem *mnPrePopup;
        TMenuItem *mnPreFont;
        TMenuItem *mnPreBackground;
        TMenuItem *mnGo;
        TFileEdit *FileEdit1;
        TMenuItem *mnSort;
        TMenuItem *mnSortName;
        TMenuItem *mnSortExt;
        TMenuItem *mnSortUpdate;
        TMenuItem *mnSortSize;
        TPopupMenu *PopupMenu1;
        TMenuItem *Command1;
        TMenuItem *mnPreGo;
        TFontDialog *FontDialog1;
        TColorDialog *ColorDialog1;
        TMenuItem *mnPreFontColor;
        TMenuItem *mnMask;
        TMenuItem *Util1;
        TMenuItem *mnPreUtil;
        void __fastcall ListBox1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall ListBox1KeyPress(TObject *Sender, char &Key);
        void __fastcall ListBox1DblClick(TObject *Sender);
        void __fastcall mnOpenDirClick(TObject *Sender);
        void __fastcall FileEdit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall mnRenameClick(TObject *Sender);
        void __fastcall Quit1Click(TObject *Sender);
        void __fastcall mnCopyClick(TObject *Sender);
        void __fastcall mnMoveClick(TObject *Sender);
        void __fastcall mnNewDirClick(TObject *Sender);
        void __fastcall Delete1Click(TObject *Sender);
        void __fastcall Reload1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnAddgoClick(TObject *Sender);
        void __fastcall mnApplicationClick(TObject *Sender);
        void __fastcall mnSortNameClick(TObject *Sender);
        void __fastcall ListBox1Click(TObject *Sender);
        void __fastcall mnPreGeneralClick(TObject *Sender);
        void __fastcall Command1Click(TObject *Sender);
        void __fastcall mnPrePopupClick(TObject *Sender);
        void __fastcall mnPreGoClick(TObject *Sender);
        void __fastcall ListBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall mnPreFontClick(TObject *Sender);
        void __fastcall mnPreBackgroundClick(TObject *Sender);
        void __fastcall mnPreFontColorClick(TObject *Sender);
        void __fastcall mnMaskClick(TObject *Sender);
        void __fastcall mnPreUtil4ExtClick(TObject *Sender);
        void __fastcall mnPreUtilClick(TObject *Sender);
private:	// 桼
        int __fastcall OpenFrmInput(AnsiString tit,AnsiString def,bool isCmb,char mo);

        void __fastcall Split(AnsiString txt,char c);
        void __fastcall RefreshCaption(void);
        bool __fastcall DirExists(AnsiString st);
        bool __fastcall Ok(AnsiString st,AnsiString exe);
        void __fastcall Hiraku(AnsiString apps);

	void __fastcall AddLi(AnsiString st);
	void __fastcall AddLiInfo(bool isDir);
        void __fastcall SortLiFi(void);
        void __fastcall Update(void);
public:		// 桼
        __fastcall TFrmBixx(TComponent* Owner);
        void __fastcall ModalDone(int result);
        int mo_sort,numDrive,cur_fdir;
        int keycount,keyhis,mo_modal;
        int *sha,cnt_ren,max_ren; //File ope
        bool isCurmove;
        int bkIndex; //backupof ListBox index
        bool upp; //Update after Hiraku
        TStringList *li_ini,*li_split,*li_fdir;
        AnsiString fi_ini,di_desktop,dirname;
        AnsiString Drives,FDir,bkFDir,Mask;
	TStringList *li_fi,*li_info,*li_finfo;
	TSearchRec sr;
        bool __fastcall InitSelFiles(void);
        void __fastcall LoadIni(void);
        void __fastcall SaveIni(bool isChild);
        void __fastcall AddGoItem(AnsiString st,int tag);
        void __fastcall RefreshGo(void);
        void __fastcall GotoDir(TObject *Sender);
        bool __fastcall strReplace(AnsiString &st,AnsiString txt,AnsiString txt2);
        void __fastcall Exec(AnsiString co);
        void __fastcall AddPopup(AnsiString st,char c);
        void __fastcall RefreshPopup(void);
        void __fastcall AddUtil(AnsiString st,char c);
        void __fastcall RefreshUtil(void);
        void __fastcall RunPopup(TObject *Sender);
        void __fastcall RunUtil(TObject *Sender);
        void __fastcall DelIniHead(AnsiString hd);
        void __fastcall IniToList(AnsiString hd);
        void __fastcall SetLayout(void);
        void __fastcall ExecMacro(AnsiString exe,AnsiString st);
        void __fastcall ComeBackCursor(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmBixx *FrmBixx;
//---------------------------------------------------------------------------
#endif
